/* Gtk Widget Factory generated widget
 * http://gwf.sourceforge.net
 * Copyright (c) 1999-2000 Jeroen Benckhuijsen
*/

/* This file is Copyrighted (C) 1999-2000 by Jeroen Benckhuijsen (jfbenck@gwf.sourceforge.net)
 * Please read the license agreement below
*/

/*  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG
  #include <config.h>
#endif

#include <gtk/gtk.h>
#include "gwf_window.h"
#include <gwf_lib.h>

static GtkObjectClass *parent_class = NULL;

static void	gwf_window_class_init	(GwfWindowClass *klass);
static void	gwf_window_init		(GwfWindow *window);
static void	gwf_window_destroy	(GtkObject *object);
static void	curproj_changed_cb	(GwfProjlist *projlist,gchar *name,gpointer user_data);

guint
gwf_window_get_type (void)
{
  static guint gwf_window_type = 0;

  if (!gwf_window_type)
    {
      GtkTypeInfo gwf_window_info =
      {
        "GwfWindow",
        sizeof (GwfWindow),
        sizeof (GwfWindowClass),
        (GtkClassInitFunc) gwf_window_class_init,
        (GtkObjectInitFunc) gwf_window_init,
        /* reserved_1 */ NULL,
        /* reserved_2 */ NULL,
        (GtkClassInitFunc) NULL,
      };

      gwf_window_type = gtk_type_unique (gtk_window_get_type (), &gwf_window_info);
    }

  return gwf_window_type;
}

static void
gwf_window_class_init (GwfWindowClass *klass)
{
  GtkObjectClass *object_class;

  object_class = (GtkObjectClass*) klass;
  object_class->destroy = gwf_window_destroy;
  parent_class = gtk_type_class (gtk_window_get_type());
}

static void
gwf_window_init (GwfWindow *window)
{
  window->windowtitle = NULL;
}

static void
gwf_window_destroy (GtkObject *object)
{
  g_free(GWF_WINDOW(object)->windowtitle);
  gtk_signal_disconnect_by_data(GTK_OBJECT(GWF_WINDOW(object)->projlist),(gpointer)object);
  parent_class->destroy(object);
}

GwfWindow*
gwf_window_new(GwfProjlist *projlist)
{
  GwfWindow *window;

  window = GWF_WINDOW( gtk_type_new ( gwf_window_get_type()));
  gwf_window_construct(window,projlist);
  return window;
}

void
gwf_window_construct (GwfWindow *window,GwfProjlist *projlist)
{
  window->projlist = projlist;
  gtk_signal_connect(GTK_OBJECT(projlist),"curproj_changed",
                     GTK_SIGNAL_FUNC(curproj_changed_cb),
                     (gpointer)window);
}

void
gwf_window_set_windowtitle (GwfWindow *window,gchar* windowtitle)
{
  g_return_if_fail(window != NULL);
  g_free(window->windowtitle);
  window->windowtitle = g_strdup(windowtitle);
  gtk_window_set_title(GTK_WINDOW(window), NULL_TO_EMPTY(window->windowtitle));
}

gchar*
gwf_window_get_windowtitle (GwfWindow *window)
{
  g_return_val_if_fail(window != NULL,0);
  return window->windowtitle;
}


static void
curproj_changed_cb (GwfProjlist *projlist,gchar *name,gpointer user_data)
{
  gchar	*tmp;

  tmp = g_strdup_printf("%s : %s",GWF_WINDOW(user_data)->windowtitle, NULL_TO_EMPTY(name));
  gtk_window_set_title(GTK_WINDOW(user_data),tmp);
  g_free(tmp);
}

