/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_PROJDATA_ELEM_H
#define GWF_PROJDATA_ELEM_H

#ifdef __cplusplus
extern "C" {
#endif

#include <gtk/gtk.h>
#include <gwf_lib.h>

typedef struct _element		element;
typedef void	(*GwfElementForeachFunc)	(element *element,gpointer user_data);

struct _element
{
   gchar	*type;
   gchar	*name;
   gchar	*value;
   gboolean	set_func;
   gboolean	alloc_set_func;
   gchar	*set_code;
   gboolean	get_func;
   gboolean	alloc_get_func;
   gchar	*get_code;
};

GwfProjData*	gwf_project_element_new		(GwfProject *project);

void		gwf_project_add_element		(GwfProject *project,element *elem);
void		gwf_project_new_element		(GwfProject *project,gchar *name);
void		gwf_project_del_element		(GwfProject *project,gchar *name);
void		gwf_project_element_set_name	(GwfProject *project,gchar *name,gchar *newname);
void		gwf_project_element_set_type	(GwfProject *project,gchar *name,gchar *type);
void		gwf_project_element_set_value	(GwfProject *project,gchar *name,gchar *value);
void		gwf_project_element_set_setfunc	(GwfProject *project,gchar *name,gboolean setfunc,gboolean alloc);
void		gwf_project_element_set_setcode	(GwfProject *project,gchar *name,gchar *code);
void		gwf_project_element_set_getfunc (GwfProject *project,gchar *name,gboolean getfunc,gboolean alloc);
void		gwf_project_element_set_getcode	(GwfProject *project,gchar *name,gchar *code);
gchar*		gwf_project_element_get_type	(GwfProject *project,gchar *name);
gchar*		gwf_project_element_get_value	(GwfProject *project,gchar *name);
gboolean	gwf_project_element_get_setfunc	(GwfProject *project,gchar *name);
gboolean	gwf_project_element_get_setalloc(GwfProject *project,gchar *name);
gchar*		gwf_project_element_get_setcode	(GwfProject *project,gchar *name);
gboolean	gwf_project_element_get_getfunc	(GwfProject *project,gchar *name);
gboolean	gwf_project_element_get_getalloc(GwfProject *project,gchar *name);
gchar*		gwf_project_element_get_getcode	(GwfProject *project,gchar *name);
void		gwf_project_element_foreach	(GwfProject *project,GwfElementForeachFunc func,gpointer user_data);
element*	gwf_project_element_find	(GwfProject *project,gchar *name);

#ifdef __cplusplus
}
#endif

#endif

